
#include <stdio.h>
#include <stdlib.h>

#include <pspuser.h>

#include "common.h"
#include "memtools.h"
#include "strtool.h"
#include "unicode.h"
#include "profile.h"
#include "sceIo_Frap.h"
#include "FileWriteThread.h"

#include "ProcState.h"

static const u32 ProcStateID=0x32535250;

TProcState ProcState;

static TProcState LastProcState;

void ProcState_Init(void)
{
  ProcState.ID=ProcStateID;
  
  ProcState.GroupsIndex=0;
  
  StrCopy("ms0:/MUSIC",ProcState.LastPath);
  
  {
    TProcState_DialogIndex *ps=&ProcState.DialogIndex;
    ps->SystemMenu=0;
  }
  
  {
    TProcState_Global *ps=&ProcState.Global;
    ps->ItemsIndex=0;
  }
  
  {
    TProcState_FileList *ps=&ProcState.FileList;
    ps->ItemsIndex=0;
    ps->FilenameFontSize=14;
    ps->ShowFileIcon=true;
    ps->NumberOfLines=2;
    ps->BButtonAssignment=TProcState_FileList::EBBA_Auto;
  }
  
  {
    TProcState_PlayTab *ps=&ProcState.PlayTab;
    ps->ItemsIndex=0;
    ps->FilenameFontSize=12;
    ps->NumberOfLines=4;
    ps->MusicInfoFontSize=16;
    ps->PlayListMode=TProcState_PlayTab::EPLM_Normal;
  }
  
  {
    TProcState_Image *ps=&ProcState.Image;
    ps->ItemsIndex=0;
    ps->AutoJpegFitting=true;
  }
  
  {
    TProcState_Text *ps=&ProcState.Text;
    ps->ItemsIndex=0;
  }
  
  LastProcState=ProcState;
}

void ProcState_Free(void)
{
}

void ProcState_Load(void)
{
  ProcState_Init();
  
  SceUID fp=FrapOpenRead("settings.dat");
  if(fp<0){
    printf("ProcState read error. (0x%x)\n",fp);
    return;
  }
  
  if(FrapRead(fp,&LastProcState,sizeof(TProcState))==sizeof(TProcState)){
    if(LastProcState.ID==ProcStateID){
      ProcState=LastProcState;
    }
  }
  
  FrapClose(fp);
}

void ProcState_Save(bool AlreadyWrite)
{
  if(AlreadyWrite==false){
    if(FileWriteThread_isExecute()==true) return;
  }
  
  if(memcmp(&LastProcState,&ProcState,sizeof(TProcState))==0) return;
  LastProcState=ProcState;
  
  FileWriteThread_Stack("settings.dat",sizeof(TProcState),&ProcState);
  
//  printf("ProcState saved.\n");
}

