#pragma once

typedef struct {
  u32 SystemMenu;
} TProcState_DialogIndex;

typedef struct {
  u32 ItemsIndex;
} TProcState_Global;

typedef struct {
  u32 ItemsIndex;
  u32 FilenameFontSize;
  bool ShowFileIcon;
  u32 NumberOfLines;
  enum EBButtonAssignment {EBBA_FolderUp,EBBA_MusicStop,EBBA_Auto};
  EBButtonAssignment BButtonAssignment;
} TProcState_FileList;

typedef struct {
  u32 ItemsIndex;
  u32 FilenameFontSize;
  u32 NumberOfLines;
  u32 MusicInfoFontSize;
  enum EPlayListMode {EPLM_Normal};
  EPlayListMode PlayListMode;
} TProcState_PlayTab;

typedef struct {
  u32 ItemsIndex;
  bool AutoJpegFitting;
} TProcState_Image;

typedef struct {
  u32 ItemsIndex;
} TProcState_Text;

typedef struct {
  u32 ID;
  char LastPath[1024];
  TProcState_DialogIndex DialogIndex;
  u32 GroupsIndex;
  TProcState_Global Global;
  TProcState_FileList FileList;
  TProcState_PlayTab PlayTab;
  TProcState_Image Image;
  TProcState_Text Text;
} TProcState;

extern TProcState ProcState;

extern void ProcState_Init(void);
extern void ProcState_Free(void);
extern void ProcState_Load(void);
extern void ProcState_Save(bool AlreadyWrite);

