#pragma once

#define safemalloc(s) malloc(s)
#define safemalloc_chkmem(s) malloc(s)
#define saferealloc(p,s) realloc(p,s)
#define safefree(p) free(p)

static inline void MemSet8CPU(u8 val,void *pbuf,u32 size)
{
  u8 *_pdst=(u8*)pbuf;
  for(u32 idx=0;idx<size;idx++){
    *_pdst++=val;
  }
}

static inline void MemCopy8CPU(const void *psrc,void *pdst,u32 size)
{
  u8 *_psrc=(u8*)psrc,*_pdst=(u8*)pdst;
  for(u32 idx=0;idx<size;idx++){
    *_pdst++=*_psrc++;
  }
}

static inline void MemSet16CPU(u16 val,void *pbuf,u32 size)
{
  u16 *_pdst=(u16*)pbuf;
  for(u32 idx=0;idx<size/2;idx++){
    *_pdst++=val;
  }
}

static inline void MemCopy16CPU(const void *psrc,void *pdst,u32 size)
{
  u16 *_psrc=(u16*)psrc,*_pdst=(u16*)pdst;
  for(u32 idx=0;idx<size/2;idx++){
    *_pdst++=*_psrc++;
  }
}

static inline void MemSet32CPU(u32 val,void *pbuf,u32 size)
{
  u32 *_pdst=(u32*)pbuf;
  for(u32 idx=0;idx<size/4;idx++){
    *_pdst++=val;
  }
}

static inline void MemCopy32CPU(const void *psrc,void *pdst,u32 size)
{
  u32 *_psrc=(u32*)psrc,*_pdst=(u32*)pdst;
  for(u32 idx=0;idx<size/4;idx++){
    *_pdst++=*_psrc++;
  }
}

